RuleBook = {};
RuleBook.DEBUG 		= false;
RuleBook.inited 	= false;
RuleBook.Turn		= GLOBAL_VARS.Player1Store;
RuleBook.TurnNum	= 1;
RuleBook.IsGoLower	= false;
RuleBook.IsMirror	= false;
RuleBook.IsQueen	= false;
--**********************************************************************

function RuleBook.Do_Bundem()
	--BUNDEM CODE
	print("RuleBook.Do_Bundem()");
	local cardPile = GLOBAL_VARS.CardPile;
	
	for i = #cardPile, 1, -1 do 
	--Then remove all those entries from CardPile
		table.remove(cardPile, i);
	end
	
	print("#cardPile: "..#cardPile);
	
	--Should have some code that keeps it the same player's turn
	RuleBook.Turn = RuleBook.Turn;
	print("Deck Burnt");
	print("It's still "..RuleBook.Turn.name.."'s Turn.");
	RuleBook.IsBundem = false;
	
end

function RuleBook.Do_Reset()
	print("RuleBook.Do_Reset()");
	RuleBook.TurnChange();
	--Change turns at the start of every attribute call
	--so the functions can implement the played card checks against the next player
	--Nothing really happens here as the deck is not burnt, the number is just reset
end

function RuleBook.Do_Go_Lower()
	print("RuleBook.Do_Go_Lower()");
	RuleBook.IsGoLower = true;
	
	RuleBook.TurnChange();
end

function RuleBook.Do_Mirror()
	print("RuleBook.Do_Mirror()");
	RuleBook.IsMirror = true;
	RuleBook.TurnChange();
end

function RuleBook.Do_Queen()
	print("RuleBook.Do_Queen()");
	RuleBook.IsQueen = true;
	RuleBook.TurnChange();
end

function RuleBook.MultipleCheck()
	print("RuleBook.MultipleCheck()");
	--This is an initial check to see if there are attempted multiple cards being played
	--and whether not they are playable.
	
	local cardsToBePlayed = GLOBAL_VARS.CardsToBePlayed;
	local cardPile = GLOBAL_VARS.CardPile;
	--Checks if there's more than one card being played
	--A repeat of the check from magicRules() that will
	--not have been carried out otherwise.
	local done = {}
	
	--Checking whether the multiples are playable
	if( #cardsToBePlayed > 1 ) then
		print("MultipleCheck: More than one card to be played");
		for i = 1, #cardsToBePlayed do
			for j = i+1, #cardsToBePlayed do
				if( cardsToBePlayed[i].number == cardsToBePlayed[j].number ) then
					if not done[i] then
						done[i] = true;
					end
					if not done[j] then
						done[j] = true;
					end
				else
					if not done[j] then
						done[i] = false;
					end
				end
				for i = 1, #done do
					if( done[i] == false ) then
						print("You can only play multiples of the same card");
						RuleBook.RemoveCards();
						break;
					else
						if( i == #done ) then
							RuleBook.PlayCards();
						end
					end
				end
			end
		end
	else
		--Again, performing checks that would have been misses if MagicTest was called
		print("MultipleCheck: No Multiples to play");
		RuleBook.PlayCards();
	end
end

function RuleBook.CardPileAndHandCheck()
	
	--This is a check to see if the card pile has 4 multiples
	--in a row, in which case the deck must be burnt, or if
	--there a magic card has been played.
	print("RuleBook.CardPileAndHandCheck()");
	local cardPile	= GLOBAL_VARS.CardPile;
	print("CardPileHandCheck: Card pile IDX: "..#cardPile);
	for i = 1, #cardPile do print(cardPile[i].picture) end
	if( #cardPile > 3 ) then
		if( cardPile[#cardPile].number == cardPile[#cardPile-1].number ) then
		--If the number of the last card on the played card pile, and that of the card before it are the same
			if( cardPile[#cardPile-2].number == cardPile[#cardPile-3].number ) then
			--If the number of the 3rd and 4th last cards are the same
				if( cardPile[#cardPile-1].number == cardPile[#cardPile-2].number ) then
				--If the number of the 2nd and 3rd last cards are the same
					print("CardPileHandCheck: FOUR EQUAL RANKING CARDS, BURNING DECK");
					RuleBook.Do_Bundem(); --Burn the deck as there are four multiples
				else 					  --Else check if the last played card has an attribute.
					print("CardPileHandCheck: nothing to burn");
					RuleBook.MagicTest();
				end
			else
				print("CardPileHandCheck: nothing to burn");
				RuleBook.MagicTest();
			end
		else
			print("CardPileHandCheck: nothing to burn");
			RuleBook.MagicTest();
		end	
	else
		print("CardPileHandCheck: nothing to burn");
		RuleBook.MagicTest();
	end
end

function RuleBook.MagicTest()
	print("RuleBook.MagicTest()");
	local cardPile = GLOBAL_VARS.CardPile;

	if ( cardPile[#cardPile].Attribute ) then			--One of the most important parts of code in the program. 
		print(cardPile[#cardPile].Attribute)
		print(RuleBook.Do_Bundem)
		--ATTRIBUTES[cardPile[#cardPile].Attribute]()	--This activates the card attributes.
		cardPile[#cardPile].Attribute()
	else												--If not change turns
		RuleBook.TurnChange();
	end
end

function RuleBook.PlayCards()
	
	local cardsToBePlayed = GLOBAL_VARS.CardsToBePlayed;
	local Player1	= GLOBAL_VARS.Player1Store;
	local Player2	= GLOBAL_VARS.Player2Store;
	local cardPile	= GLOBAL_VARS.CardPile;
	
	print("RuleBook.PlayCards()");
	
	--Remove the selected cards from the player's hand
	
	print("PlayCards: #cardsToBePlayed: "..#cardsToBePlayed);
	
	for i = 1, #cardsToBePlayed do
		table.insert(cardPile, cardsToBePlayed[i]); --Placing all entries in CardsToBePlayed onto CardPile
	end
	
	print("PlayCards: Playing Cards");
	
	print("PlayCards: CARDPILE: "..#cardPile);
	print("PlayCards: Removing entries from cardsToBePlayed");
	RuleBook.RemoveHandCards(cardPile, cardsToBePlayed);
	--for i = #cardsToBePlayed, 1, -1 do
	--	table.remove(cardsToBePlayed, i);
	--Removing all entries in CardsToBePlayed
--	end
	
	print("PlayCards: #cardsToBePlayed: "..#cardsToBePlayed);
	
	--DEBUG CODE
	if( #cardsToBePlayed > 0 ) then
		for i = 1, #cardsToBePlayed do print(cardsToBePlayed[i].picture) end
	end
	--Some minor housekeeping to avoid bugs
	for i = 1, #Player1.hand do
		if( Player1.hand[i].isSelected == true ) then
			Player1.hand[i].isSelected = false;
		end
	end

	for i = 1, #Player2.hand do
		if( Player2.hand[i].isSelected == true ) then
			Player2.hand[i].isSelected = false;
		end
	end
	
	for i = 1, #cardPile do
		if( cardPile[i].isSelected == true ) then
			cardPile[i].isSelected = false;
		end
	end
	
	print("PlayCards: picking up");
	
	if( RuleBook.TurnNum == 1 ) then
		Player1.IsBottomRsv = false; --This is for later in the game, so only one card is picked up
		RuleBook.RemoveHandCards(cardPile, Player1.hand);
		RuleBook.ReserveCardRules(Player1); --Player picks up
		table.sort(Player1.hand, function(a,b) return a.number<b.number end)
	else
		RuleBook.IsBottomRsv = false;
		RuleBook.ReserveCardRules(Player2);
		RuleBook.RemoveHandCards(cardPile, Player2.hand);
	end
	
	print("PlayCards: #cardsToBePlayed: "..#cardsToBePlayed);
	
	RuleBook.CardPileAndHandCheck();	--This calls the function to check for multiples
	
end

function RuleBook.RemoveCards()
	print("RuleBook.RemoveCards()");
		
	for i = 1, #GLOBAL_VARS.CardsToBePlayed do	--And all entries are removed from the CardsToBePlayed table		
		table.remove(GLOBAL_VARS.CardsToBePlayed,i);
	end
	
end

function RuleBook.TurnChange()
	print("RuleBook.TurnChange()");
	playButtonisSelected = false;
	--This changes turns
	--Code is pretty self explanatory
	
	RuleBook.TurnNum = RuleBook.TurnNum * -1;
	--This starts equal to 1.
	
	if( RuleBook.TurnNum == 1 ) then
		RuleBook.Turn = GLOBAL_VARS.Player1Store;
		print("It's "..RuleBook.Turn.name.."'s Turn.");
		
	elseif( RuleBook.TurnNum == -1 ) then
		RuleBook.Turn = GLOBAL_VARS.Player2Store;
		print("It's "..RuleBook.Turn.name.."'s Turn.");
	end
end

function RuleBook.CardOrder()
	print("RuleBook.CardOrder()");
	local cardPile		= GLOBAL_VARS.CardPile;
	local cardsToBePlayed = GLOBAL_VARS.CardsToBePlayed
	--This code is an error check for the human player.
	--A similar one exists in the Opponent AI code.
	
	if( cardsToBePlayed[1] ) then
		print("CardOrder: CARD_PILE: "..#cardPile);
		print("CardOrder: CardsToBePlayed...");
		for i = 1, #cardsToBePlayed do print(cardsToBePlayed[i].picture) end
		
		if( #cardPile > 0 and cardPile[#cardPile].Attribute ) then
			print("CardOrder: Calling Magic Rules");
			RuleBook.MagicRules();
		else
			if( #cardsToBePlayed < 2 ) then
				print("CardOrder: #cardsToBePlayed = 1");
				if( (cardPile[#cardPile] ~= nil) and
					(cardPile[#cardPile].Attribute == nil) )then
					print("CardOrder: Card played last was not special");
					--If the last card played is normal
					if( cardsToBePlayed[1].number >= cardPile[#cardPile].number or
						(cardsToBePlayed[1].Attribute and cardsToBePlayed[1].Attribute == RuleBook.Do_Reset) or
						(cardsToBePlayed[1].Attribute and cardsToBePlayed[1].Attribute == RuleBook.Do_Mirror) or
						(cardsToBePlayed[1].Attribute and cardsToBePlayed[1].Attribute == RuleBook.Do_Bundem)) then
						RuleBook.PlayCards();
					else
						RuleBook.RemoveCards();
						print("You have to play a card higher than the last one");
					end
				
				elseif( cardPile[#cardPile] == nil or 
						(cardPile[#cardPile].Attribute and 
						cardPile[#cardPile].Attribute == RuleBook.Do_Reset)) then
					--If the pile is empty or the last card was a reset any card can be played
					RuleBook.PlayCards();
					
				end
			else
				print("CardOrder: MULTIPLES");
				
				print("CardOrder: Cards to be played: ");
				for i = 1, #cardsToBePlayed do print(cardsToBePlayed[i].picture) end
				
				local done = {}
				
				--Checking whether the multiples are playable
				for i = 1, #cardsToBePlayed do
					for j = i+1, #cardsToBePlayed do
						if( cardsToBePlayed[i].number == cardsToBePlayed[j].number ) then
							if not done[i] then
								done[i] = true;
							end
							if not done[j] then
								done[j] = true;
							end
						else
							if not done[j] then
								done[i] = false;
							end
						end
					end
				end
				for i = 1, #done do
					if( done[i] == false ) then
						print("You can only play multiples of the same card");
						RuleBook.RemoveCards();
						break;
					else
						if( i == #done ) then
							RuleBook.PlayCards();
						end
					end
				end
			end
		end
	else
		print("You need to select a card first");
	end
end

function RuleBook.WinCheck(player)
	print("RuleBook.WinCheck()");
	
	print(RuleBook.Turn.name.." Wins");	
	
end

function RuleBook.Pickup(player)

	print("RuleBook.Pickup()");
	
	local cardPile = GLOBAL_VARS.CardPile;
	
	for i = 1, #cardPile do	--Insert all the cards in CardPile into the player's hand
		print("Picking Up: "..cardPile[i].picture);
		table.insert(player.hand, cardPile[i]);
	end
	
	RuleBook.LastPickUp();				--Call the last pick up function to memorize details of the pick up.
	
	print("Card Pile cards picked up");
	print("Entries being removed from card pile");
	for i = #cardPile, 1, -1 do --Then remove all those entries from CardPile
		table.remove(cardPile, i);
	end
	
	print("cardPile: "..#cardPile);
	
	RuleBook.TurnChange();
end
	
function RuleBook.ReserveCardRules(player)
-- This function checks for and implements the reserve card rules
	print("RuleBook.ReserveCardRules()");
	
	local sum = 0;
	
	if( #player.hand < GLOBAL_VARS.MaxHand ) then 
	--If player hand is below the MaxHand
		if( #Deck.cards ~= 0 ) then				
		--And the deck isn't empty			  
			sum = GLOBAL_VARS.MaxHand - #player.hand;	
			--Work out how much less it is than MaxHand
			for i = 1, sum do
				table.insert(player.hand, Deck.cards[#Deck.cards]); 
				table.remove(Deck.cards, #Deck.cards); 
				--And input cards into the hand of that amount
			end
			print(player.name.." hand: ");
			
			for i = 1, #player.hand do
				print(player.hand[i].picture);
			end
			
	--[[		for i = sum, 1, -1 do							 
			--Then remove those entries from the deck
				
			end]]
		else
			if( #player.hand == 0 ) then			
			--othwerise if the deck is empty and the player has no cards in their hand
				if( #player.TopResvCards ~= 0 ) then 
				--and TopResvCards isn't empty
					for i = 1, #player.TopResvCards do 
					--transfer it's contents to the player's hand
						table.insert(player.hand, player.TopResvCards[1]);
						table.remove(player.TopResvCards, 1);
					end
					
				--[[	for i = #player.TopResvCards, 1, -1 do 
					--then remove those entries from TopResvCards
						
					end]]
				else
					if( #player.BottomResvCards ~= 0 ) then 
					--otherwise, if that option is exhausted perform the same check on BottomResvCards
						if( player.IsBottomRsv == false ) then
							player.IsBottomRsv = true;
							table.insert(player.hand, player.BottomResvCards[1]);
							--and transfer the cards one per check.
							table.remove(player.BottomResvCards, 1);
						end
					else
						RuleBook.WinCheck(player); 
						--If the player has absolutely no cards then they win the game
					end
				end
			end		
		end	
	else
		print("Nothing to pick up");
	end
end

function RuleBook.LastPickUp()
	--This function saves the contents of the last pickup
	--and the name of the player for the AI to analyse
	print("RuleBook.LastPickUp()");
	
	for i = 1, #GLOBAL_VARS.CardPile do 
		table.insert(GLOBAL_VARS.LastPickUp, GLOBAL_VARS.CardPile[i]);
	end	
	
	GLOBAL_VARS.LastPickUpName = RuleBook.Turn.name;
end

function RuleBook.RemoveHandCards(cardsToCompare, playerHand)
	print("RuleBook.RemoveHandCards()");
--This removes the card to be played from the hand
	for i = #cardsToCompare, 1, -1 do 
		for j = #playerHand, 1, -1 do
--Iterating backwards by 1
--In a double for loop
--This helps avoid some of
--the more subtle errors that can
--occur when removing cards.
--if entries in the two tables are identical
--remove that entry from the hand.
			if( cardsToCompare[i].number == playerHand[j].number and 
				cardsToCompare[i].suit == playerHand[j].suit ) then
				table.remove(playerHand, j);
			end
		end
	end
end

function RuleBook.CardSwap()
	
	--Allowing player 1 to change their cards out at the start
	local hand = GLOBAL_VARS.Player1Store.hand;
	local topRsv = GLOBAL_VARS.Player1Store.TopResvCards;
	
	for i = #topRsv, 1, -1 do
		for j = #hand, 1, -1 do
			if( hand[i].isSelected == true and 
				topRsv[j].isSelected == true )then
				--Reversing the i and j so the cards
				--swap out in the right position
				hand[i].isSelected = false;
				topRsv[j].isSelected = false;
				
				local temp = {};
				local temp2 = {};
				
				table.insert(temp, hand[i]);
				table.insert(temp2,topRsv[j]);
				
				table.remove(hand, i);
				table.remove(topRsv, j);
				
				table.insert(hand, i, temp2[1]);
				table.insert(topRsv, j, temp[1]);
			end
		end
	end
end

function RuleBook.MagicRules()
	print("RuleBook.MagicRules()");
	local cardsToBePlayed = GLOBAL_VARS.CardsToBePlayed;
	local cardPile	= GLOBAL_VARS.CardPile;
	
	if( RuleBook.IsGoLower == true ) then
		print("Magic Rules: Go Lower True");
		if( cardsToBePlayed[1] ) then					
		--If there's a card to be played
			print("Magic Rules: Card to be played");
			if( cardsToBePlayed[1].number > 7 ) then	--If that card is greater than an 8 (mirror card/number 7).
				print("You have to play a 7, a Mirror (8), or a card lower than 7");
				RuleBook.RemoveCards();
			else
				print("Magic Rules: Card is fine");
				RuleBook.IsGoLower = false;
				RuleBook.MultipleCheck();							
				--Check if there are multiples
			end
		end
	elseif( RuleBook.IsMirror == true ) then
		print("Magic Rules: Mirror was last played");
		if( cardsToBePlayed[1] ) then		
			if( cardPile[#cardPile-1].Attribute and cardPile[#cardPile-1].Attribute == RuleBook.Do_Go_Lower ) then	
				print("Go Lower still in effect");					
				--If the card before the 8 was a go lower then those rules still apply
				
				if( cardsToBePlayed[1].number > 7 ) then
				--If that card is greater than an 8 (mirror card/number 7).
					print("You have to play a 7, a Mirror (8), or a card lower than 7");
					RuleBook.RemoveCards();
				else
					RuleBook.IsGoLower = false;
					RuleBook.IsMirror = false;
					RuleBook.MultipleCheck();						
					--Check if there are multiples
				end
			else						
				if(	cardsToBePlayed[1].Attribute ~= RuleBook.Do_Reset and
					cardsToBePlayed[1].Attribute ~= RuleBook.Do_Mirror and
					cardsToBePlayed[1].number < cardPile[#cardPile-1].number) then	  	    
					--Otherwise it only matters what the number of the						
					--last card was. Anything lower than that card		                
					--is unplayable, unless it is a reset card.                         
					RuleBook.RemoveCards();								                
				else                                                                    
					RuleBook.IsMirror = false;                                          
					RuleBook.MultipleCheck();                                           
				end                                                                     
			end                                                                         
		end	
	elseif( RuleBook.IsQueen == true ) then
		print("Magic Rules: Queen last played");
		if( cardsToBePlayed[1] ) then				
			if( cardsToBePlayed[1].Attribute and cardsToBePlayed[1].Attribute ~= RuleBook.Do_Queen ) then
				if( cardsToBePlayed[1].number < 11) then
				
					print("You can only play Queen, King or Ace");		
					--If the card to be played is lower than a queen,
					--or a magic card that is not a queen
					RuleBook.RemoveCards()
				end
			else
				RuleBook.IsQueen = false;
				RuleBook.MultipleCheck();
			end
		end
	elseif( RuleBook.IsReset == true ) then
		print("Magic Rules: Reset Played last");
		RuleBook.MultipleCheck(); 
	end
end